# Homework Assignment 1
Your task is to accurately describe the rules of the game as a two-player zero-sum extensive form game.

### Requirements
Your program must accept the cave definition from standard input, and must write the resulting `efg` representation to standard output, i.e. the expected usage is `python main.py < cave.txt`.

You must not open, read or write to any files, and your standard output must contain only the `efg` representation without any debugging information.

### Examples, Tests, Templates and Libraries
This template uses [a library](https://github.com/votroto/cgt_bandits) written on top of [pygambit](https://gambitproject.readthedocs.io/en/latest/pyapi.html#) and [pydot](https://pypi.org/project/pydot/) to simplify the creation, and visualization of your extensive form games. You can download it directly from Github (`pip install git+https://github.com/votroto/cgt_bandits.git`. Then, see the `examples` directory). 

There is no requirement to use my library. If You are feeling adventurous, you can use `pygambit` directly, or even use the [template from last year](https://cw.fel.cvut.cz/b211/courses/cgt/game_theory), along with the `gambit` GUI. If none of the above works for You, feel free to implement the entire thing yourself.

`pygambit` can compute the equilibria and the value of your games; although, do not expect it to work for larger games. Implementing a better algorithm will be the subject of your second homework assignment.

## Input File Format
Caves have the following format
```
number_of_miners:int capture_prob:float\n
maze:Matrix[char]
```

Example
```txt
2 0.33
######
#SE-D#
#-##G#
#--E-#
######
```

Key: 
    `-` empty square, 
    `S` start, 
    `D` destination, 
    `E` possible hiding place, 
    `G` gold, 
    `#` wall) 

## Notes
 - Your goal is to formulate the problem as an extensive form game, not to try to solve it, or evaluate it in any way -- that will be your next assignment.
 - Please, test your solutions and visualize your trees.
 - There are many correct solutions. Checking whether your tree correctly describes the game is non trivial; as a result, You may receive points for incorrect solutions. We will inspect your solutions manually at most two weeks after the deadline and deduct points in case of errors.
 - Be aware that all your submissions are automatically checked for plagiarism. Please read [the CourseWare page on plagiarism and cheating](https://cw.fel.cvut.cz/b181/help/common/plagiarism_cheating) before uploading any solutions.
 - The expected length of your solution is around 150 lines of code. 
 - Do not worry about inventing the best path finding algorithm, or the most compact representation of the game. That is not the point of this assignment.
 